"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const follow_redirects_1 = require("follow-redirects");
const gunzip_maybe_1 = __importDefault(require("gunzip-maybe"));
const os_1 = __importDefault(require("os"));
const path_1 = __importDefault(require("path"));
const tar_stream_1 = __importDefault(require("tar-stream"));
const create_request_data_1 = require("./download-code-helpers/create-request-data");
const unpacker_1 = require("./download-code-helpers/unpacker");
function downloadCode(organization, repository, sha, debug) {
    console.log('DOWNLOADING:', sha);
    return new Promise((resolve, reject) => {
        const requestData = create_request_data_1.createRequestData(organization, repository, sha);
        const request = follow_redirects_1.https.get(requestData, res => {
            const tarExtractor = tar_stream_1.default.extract();
            const unpacker = new unpacker_1.TarUnpacker(debug);
            tarExtractor.on('entry', unpacker.unpackEntry.bind(unpacker));
            tarExtractor.on('error', reject);
            tarExtractor.on('finish', function () {
                resolve(path_1.default.join(os_1.default.tmpdir(), `${organization}-${repository}-${sha}`));
            });
            res.pipe(gunzip_maybe_1.default()).pipe(tarExtractor);
        });
        request.on('error', reject);
    });
}
exports.downloadCode = downloadCode;
